//+------------------------------------------------------------------+
//|                                         X2MATransformCandles.mq5 |
//|                             Copyright  2011,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Nikolay Kositsin"
#property link "farria@mail.redcom.ru"
#property description "X2MA Transform Candles"
//---   
#property version   "1.00"
//+----------------------------------------------+
//|                  |
//+----------------------------------------------+
//---     
#property indicator_separate_window
//---       6 
#property indicator_buffers 6
//---  2  
#property indicator_plots   2
//---      
#property indicator_type2   DRAW_COLOR_CANDLES
#property indicator_color2  DodgerBlue, Red
//---   
#property indicator_label2  "X2MATransformCandles Open;X2MATransformCandles High;X2MATransformCandles Low;X2MATransformCandles Close"
//+-----------------------------------+
//|    CXMA             |
//+-----------------------------------+
#include <SmoothAlgorithms.mqh> 
//+-----------------------------------+
//---    CXMA   SmoothAlgorithms.mqh
CXMA XMA1,XMA2;
//+-----------------------------------+
//|             |
//+-----------------------------------+
enum Applied_price_      //  
  {
   PRICE_CLOSE_ = 1,     // Close
   PRICE_OPEN_,          // Open
   PRICE_HIGH_,          // High
   PRICE_LOW_,           // Low
   PRICE_MEDIAN_,        // Median Price (HL/2)
   PRICE_TYPICAL_,       // Typical Price (HLC/3)
   PRICE_WEIGHTED_,      // Weighted Close (HLCC/4)
   PRICE_SIMPLE,         // Simple Price (OC/2)
   PRICE_QUARTER_,       // Quarted Price (HLOC/4) 
   PRICE_TRENDFOLLOW0_,  // TrendFollow_1 Price 
   PRICE_TRENDFOLLOW1_   // TrendFollow_2 Price 
  };
/*enum Smooth_Method -     SmoothAlgorithms.mqh
  {
   MODE_SMA_,  // SMA
   MODE_EMA_,  // EMA
   MODE_SMMA_, // SMMA
   MODE_LWMA_, // LWMA
   MODE_JJMA,  // JJMA
   MODE_JurX,  // JurX
   MODE_ParMA, // ParMA
   MODE_T3,    // T3
   MODE_VIDYA, // VIDYA
   MODE_AMA,   // AMA
  }; */
//+-----------------------------------+
//|         |
//+-----------------------------------+
input Smooth_Method MA_Method1=MODE_SMA;    //     
input int Length1=12;                       //                       
input int Phase1=15;                        //   ,
input Smooth_Method MA_Method2=MODE_JJMA;   //     
input int Length2= 5;                       //    
input int Phase2=15;                        //   
input Applied_price_ IPC=PRICE_CLOSE;       //  
input int Shift=0;                          //      
input int PriceShift=0;                     //      
input color BidColor=Red;                   //   Bid
input ENUM_LINE_STYLE BidStyle=STYLE_SOLID; //   Bid
//+-----------------------------------+
//---   ,   
//---      
double ExtBuffer[];
double ExtOpenBuffer[];
double ExtHighBuffer[];
double ExtLowBuffer[];
double ExtCloseBuffer[];
double ExtColorBuffer[];
//---      
int StartBars,StartBars1,StartBars2;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit()
  {
//---     
   StartBars1=XMA1.GetStartBars(MA_Method1, Length1, Phase1);
   StartBars2=XMA2.GetStartBars(MA_Method2, Length2, Phase2);
   StartBars=StartBars1+StartBars2;
//---       
   XMA1.XMALengthCheck("Length1", Length1);
   XMA2.XMALengthCheck("Length2", Length2);
//---       
   XMA1.XMAPhaseCheck("Phase1", Phase1, MA_Method1);
   XMA2.XMAPhaseCheck("Phase2", Phase2, MA_Method2);

//---      
   SetIndexBuffer(0,ExtBuffer,INDICATOR_CALCULATIONS);
   SetIndexBuffer(1,ExtOpenBuffer,INDICATOR_DATA);
   SetIndexBuffer(2,ExtHighBuffer,INDICATOR_DATA);
   SetIndexBuffer(3,ExtLowBuffer,INDICATOR_DATA);
   SetIndexBuffer(4,ExtCloseBuffer,INDICATOR_DATA);
   
//---   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   PlotIndexSetDouble(3,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   PlotIndexSetDouble(4,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   
//---    ExtColorBuffer[]       
   SetIndexBuffer(5,ExtColorBuffer,INDICATOR_COLOR_INDEX);
//---       1
   PlotIndexSetInteger(5,PLOT_DRAW_BEGIN,StartBars);

//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);

//---      
   string shortname;
   string Smooth1=XMA1.GetString_MA_Method(MA_Method1);
   string Smooth2=XMA1.GetString_MA_Method(MA_Method2);
   StringConcatenate(shortname,"X2MA Transform Candles(",Length1,", ",Length2,", ",Smooth1,", ",Smooth2,")");
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);

//---    Bid   
   IndicatorSetInteger(INDICATOR_LEVELS,1);
   IndicatorSetInteger(INDICATOR_LEVELCOLOR,BidColor);
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,BidStyle);
//---   
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---       
   if(rates_total<StartBars) return(0);

//---       
   double price_,x1xma,x2xma;
//---        
   int first,bar;

//---    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
      first=0;                   //      
   else first=prev_calculated-1; //      

//---    
   for(bar=first; bar<rates_total && !IsStopped(); bar++)
     {
      //---   PriceSeries     price_
      price_=PriceSeries(IPC,bar,open,low,high,close);

      //---    XMASeries. 
      //---     begin   StartBars1 . .   XMA   
      x1xma = XMA1.XMASeries(0, prev_calculated, rates_total, MA_Method1, Phase1, Length1, price_, bar, false);
      x2xma = XMA2.XMASeries(StartBars1, prev_calculated, rates_total, MA_Method2, Phase2, Length2,  x1xma, bar, false);
      //--- 
      if(bar>StartBars)
        {
         ExtOpenBuffer [bar]=open[bar]-x2xma;
         ExtCloseBuffer[bar]=close[bar]-x2xma;
         ExtHighBuffer [bar]=high[bar]-x2xma;
         ExtLowBuffer  [bar]=low[bar]-x2xma;
         ExtBuffer[bar]=ExtCloseBuffer[bar];
        }
      else
        {
         ExtOpenBuffer [bar]=EMPTY_VALUE;
         ExtCloseBuffer[bar]=EMPTY_VALUE;
         ExtHighBuffer [bar]=EMPTY_VALUE;
         ExtLowBuffer  [bar]=EMPTY_VALUE;
         ExtBuffer[bar]=EMPTY_VALUE;
         continue;
        }

      //---  
      if(ExtOpenBuffer[bar]<ExtCloseBuffer[bar]) ExtColorBuffer[bar]=0.0;
      else                                       ExtColorBuffer[bar]=1.0;
     }

//---    Bid     
   IndicatorSetDouble(INDICATOR_LEVELVALUE,0,ExtCloseBuffer[rates_total-1]);
//---     
   return(rates_total);
  }
//+------------------------------------------------------------------+
